---
title: llarp::layers::flow::Deprecated_SNodeEndpoint
summary: shim for endpointbase on snode. 

---

# llarp::layers::flow::Deprecated_SNodeEndpoint



shim for endpointbase on snode. 


`#include <deprecated_flow_layer_pimpl.hpp>`

Inherits from [llarp::EndpointBase](Classes/classllarp_1_1EndpointBase.md)

## Public Functions

|                | Name           |
| -------------- | -------------- |
| | **[Deprecated_SNodeEndpoint](Classes/classllarp_1_1layers_1_1flow_1_1Deprecated__SNodeEndpoint.md#function-deprecated-snodeendpoint)**([AbstractRouter](Classes/structllarp_1_1AbstractRouter.md) & router) |
| virtual bool | **[LookupRC](Classes/classllarp_1_1layers_1_1flow_1_1Deprecated__SNodeEndpoint.md#function-lookuprc)**([RouterID](Classes/structllarp_1_1RouterID.md) remote, RouterLookupHandler handler) override |
| virtual std::string_view | **[endpoint_name](Classes/classllarp_1_1layers_1_1flow_1_1Deprecated__SNodeEndpoint.md#function-endpoint-name)**() const override |
| virtual std::optional< [EndpointBase::SendStat](Classes/structllarp_1_1EndpointBase_1_1SendStat.md) > | **[GetStatFor](Classes/classllarp_1_1layers_1_1flow_1_1Deprecated__SNodeEndpoint.md#function-getstatfor)**(AddressVariant_t remote) const override<br>get statistics about how much traffic we sent and recv'd to a remote endpoint  |
| virtual void | **[SRVRecordsChanged](Classes/classllarp_1_1layers_1_1flow_1_1Deprecated__SNodeEndpoint.md#function-srvrecordschanged)**() override<br>called when srv data changes in some way  |
| virtual std::unordered_set< AddressVariant_t > | **[AllRemoteEndpoints](Classes/classllarp_1_1layers_1_1flow_1_1Deprecated__SNodeEndpoint.md#function-allremoteendpoints)**() const override<br>list all remote endpoint addresses we have that are mapped  |
| virtual AddressVariant_t | **[LocalAddress](Classes/classllarp_1_1layers_1_1flow_1_1Deprecated__SNodeEndpoint.md#function-localaddress)**() const override<br>get our local address  |
| virtual [quic::TunnelManager](Classes/classllarp_1_1quic_1_1TunnelManager.md) * | **[GetQUICTunnel](Classes/classllarp_1_1layers_1_1flow_1_1Deprecated__SNodeEndpoint.md#function-getquictunnel)**() override |
| virtual std::optional< [service::ConvoTag](Classes/structllarp_1_1service_1_1ConvoTag.md) > | **[GetBestConvoTagFor](Classes/classllarp_1_1layers_1_1flow_1_1Deprecated__SNodeEndpoint.md#function-getbestconvotagfor)**(AddressVariant_t ) const override |
| virtual bool | **[Configure](Classes/classllarp_1_1layers_1_1flow_1_1Deprecated__SNodeEndpoint.md#function-configure)**(const [NetworkConfig](Classes/structllarp_1_1NetworkConfig.md) & netconf, const [DnsConfig](Classes/structllarp_1_1DnsConfig.md) & dnsconf) override |
| virtual std::optional< AddressVariant_t > | **[GetEndpointWithConvoTag](Classes/classllarp_1_1layers_1_1flow_1_1Deprecated__SNodeEndpoint.md#function-getendpointwithconvotag)**([service::ConvoTag](Classes/structllarp_1_1service_1_1ConvoTag.md) tag) const override |
| virtual const EventLoop_ptr & | **[Loop](Classes/classllarp_1_1layers_1_1flow_1_1Deprecated__SNodeEndpoint.md#function-loop)**() override |
| virtual void | **[MarkAddressOutbound](Classes/classllarp_1_1layers_1_1flow_1_1Deprecated__SNodeEndpoint.md#function-markaddressoutbound)**(AddressVariant_t remote) override<br>will mark a remote as something we want to initiate a flow to.  |
| virtual void | **[LookupServiceAsync](Classes/classllarp_1_1layers_1_1flow_1_1Deprecated__SNodeEndpoint.md#function-lookupserviceasync)**(std::string name, std::string service, std::function< void(std::vector< [dns::SRVData](Classes/structllarp_1_1dns_1_1SRVData.md) >)> resultHandler) override<br>lookup srv records async  |
| virtual bool | **[SendToOrQueue](Classes/classllarp_1_1layers_1_1flow_1_1Deprecated__SNodeEndpoint.md#function-sendtoorqueue)**([service::ConvoTag](Classes/structllarp_1_1service_1_1ConvoTag.md) tag, std::vector< byte_t > data, service::ProtocolType t) override |
| virtual bool | **[EnsurePathTo](Classes/classllarp_1_1layers_1_1flow_1_1Deprecated__SNodeEndpoint.md#function-ensurepathto)**(AddressVariant_t addr, std::function< void(std::optional< [service::ConvoTag](Classes/structllarp_1_1service_1_1ConvoTag.md) >)> hook, llarp_time_t timeout) override<br>MUST call MarkAddressOutbound first if we are initiating the flow to the remote.  |
| const std::shared_ptr< [exit::SNodeSession](Classes/structllarp_1_1exit_1_1SNodeSession.md) > & | **[autovivify_session_to](Classes/classllarp_1_1layers_1_1flow_1_1Deprecated__SNodeEndpoint.md#function-autovivify-session-to)**([RouterID](Classes/structllarp_1_1RouterID.md) remote) |

## Additional inherited members

**Public Classes inherited from [llarp::EndpointBase](Classes/classllarp_1_1EndpointBase.md)**

|                | Name           |
| -------------- | -------------- |
| struct | **[QUICMappingInfo](Classes/structllarp_1_1EndpointBase_1_1QUICMappingInfo.md)** <br>info about a quic mapping  |
| struct | **[SendStat](Classes/structllarp_1_1EndpointBase_1_1SendStat.md)**  |

**Public Types inherited from [llarp::EndpointBase](Classes/classllarp_1_1EndpointBase.md)**

|                | Name           |
| -------------- | -------------- |
| using std::variant< [service::Address](Classes/structllarp_1_1service_1_1Address.md), [RouterID](Classes/structllarp_1_1RouterID.md) > | **[AddressVariant_t](Classes/classllarp_1_1EndpointBase.md#using-addressvariant-t)**  |

**Public Functions inherited from [llarp::EndpointBase](Classes/classllarp_1_1EndpointBase.md)**

|                | Name           |
| -------------- | -------------- |
| virtual | **[~EndpointBase](Classes/classllarp_1_1EndpointBase.md#function-~endpointbase)**() =default |
| std::optional< [QUICMappingInfo](Classes/structllarp_1_1EndpointBase_1_1QUICMappingInfo.md) > | **[GetQUICMappingInfoByID](Classes/classllarp_1_1EndpointBase.md#function-getquicmappinginfobyid)**(int stream_id) const<br>maybe get quic mapping info given its stream id returns std::nullopt if we have no stream given that id  |
| void | **[PutSRVRecord](Classes/classllarp_1_1EndpointBase.md#function-putsrvrecord)**([dns::SRVData](Classes/structllarp_1_1dns_1_1SRVData.md) srv)<br>add an srv record to this endpoint's descriptor  |
| virtual std::shared_ptr< [dns::Server](Classes/classllarp_1_1dns_1_1Server.md) > | **[DNS](Classes/classllarp_1_1EndpointBase.md#function-dns)**() const<br>get dns serverr if we have on on this endpoint  |
| bool | **[DelSRVRecordIf](Classes/classllarp_1_1EndpointBase.md#function-delsrvrecordif)**(std::function< bool(const [dns::SRVData](Classes/structllarp_1_1dns_1_1SRVData.md) &)> filter)<br>remove srv records from this endpoint that match a filter for each srv record call it with filter, remove if filter returns true return if we removed any srv records  |
| std::set< [dns::SRVData](Classes/structllarp_1_1dns_1_1SRVData.md) > | **[SRVRecords](Classes/classllarp_1_1EndpointBase.md#function-srvrecords)**() const<br>get copy of all srv records  |
| virtual void | **[LookupNameAsync](Classes/classllarp_1_1EndpointBase.md#function-lookupnameasync)**(std::string name, std::function< void(std::optional< AddressVariant_t >)> resultHandler) =0 |
| virtual void | **[start_endpoint](Classes/classllarp_1_1EndpointBase.md#function-start-endpoint)**()<br>called to do any deferred startup items after configure.  |
| virtual void | **[stop_endpoint](Classes/classllarp_1_1EndpointBase.md#function-stop-endpoint)**()<br>initiate shutdown of all periodic operations.  |
| virtual void | **[periodic_tick](Classes/classllarp_1_1EndpointBase.md#function-periodic-tick)**()<br>called in a periodic event loop timer.  |
| virtual void | **[event_loop_pump](Classes/classllarp_1_1EndpointBase.md#function-event-loop-pump)**()<br>called in an idempotent event loop handler after reading io each tick.  |


## Public Functions Documentation

### function Deprecated_SNodeEndpoint

```cpp
inline explicit Deprecated_SNodeEndpoint(
    AbstractRouter & router
)
```


### function LookupRC

```cpp
inline virtual bool LookupRC(
    RouterID remote,
    RouterLookupHandler handler
) override
```


**Reimplements**: [llarp::EndpointBase::LookupRC](Classes/classllarp_1_1EndpointBase.md#function-lookuprc)


### function endpoint_name

```cpp
inline virtual std::string_view endpoint_name() const override
```


**Reimplements**: [llarp::EndpointBase::endpoint_name](Classes/classllarp_1_1EndpointBase.md#function-endpoint-name)


### function GetStatFor

```cpp
inline virtual std::optional< EndpointBase::SendStat > GetStatFor(
    AddressVariant_t remote
) const override
```

get statistics about how much traffic we sent and recv'd to a remote endpoint 

**Reimplements**: [llarp::EndpointBase::GetStatFor](Classes/classllarp_1_1EndpointBase.md#function-getstatfor)


### function SRVRecordsChanged

```cpp
inline virtual void SRVRecordsChanged() override
```

called when srv data changes in some way 

**Reimplements**: [llarp::EndpointBase::SRVRecordsChanged](Classes/classllarp_1_1EndpointBase.md#function-srvrecordschanged)


### function AllRemoteEndpoints

```cpp
inline virtual std::unordered_set< AddressVariant_t > AllRemoteEndpoints() const override
```

list all remote endpoint addresses we have that are mapped 

**Reimplements**: [llarp::EndpointBase::AllRemoteEndpoints](Classes/classllarp_1_1EndpointBase.md#function-allremoteendpoints)


### function LocalAddress

```cpp
inline virtual AddressVariant_t LocalAddress() const override
```

get our local address 

**Reimplements**: [llarp::EndpointBase::LocalAddress](Classes/classllarp_1_1EndpointBase.md#function-localaddress)


### function GetQUICTunnel

```cpp
inline virtual quic::TunnelManager * GetQUICTunnel() override
```


**Reimplements**: [llarp::EndpointBase::GetQUICTunnel](Classes/classllarp_1_1EndpointBase.md#function-getquictunnel)


### function GetBestConvoTagFor

```cpp
inline virtual std::optional< service::ConvoTag > GetBestConvoTagFor(
    AddressVariant_t 
) const override
```


**Reimplements**: [llarp::EndpointBase::GetBestConvoTagFor](Classes/classllarp_1_1EndpointBase.md#function-getbestconvotagfor)


### function Configure

```cpp
inline virtual bool Configure(
    const NetworkConfig & netconf,
    const DnsConfig & dnsconf
) override
```


**Reimplements**: [llarp::EndpointBase::Configure](Classes/classllarp_1_1EndpointBase.md#function-configure)


### function GetEndpointWithConvoTag

```cpp
inline virtual std::optional< AddressVariant_t > GetEndpointWithConvoTag(
    service::ConvoTag tag
) const override
```


**Reimplements**: [llarp::EndpointBase::GetEndpointWithConvoTag](Classes/classllarp_1_1EndpointBase.md#function-getendpointwithconvotag)


### function Loop

```cpp
inline virtual const EventLoop_ptr & Loop() override
```


**Reimplements**: [llarp::EndpointBase::Loop](Classes/classllarp_1_1EndpointBase.md#function-loop)


### function MarkAddressOutbound

```cpp
inline virtual void MarkAddressOutbound(
    AddressVariant_t remote
) override
```

will mark a remote as something we want to initiate a flow to. 

**Reimplements**: [llarp::EndpointBase::MarkAddressOutbound](Classes/classllarp_1_1EndpointBase.md#function-markaddressoutbound)


making this explicit prevents us from doing weird things when we are the recipient. 


### function LookupServiceAsync

```cpp
inline virtual void LookupServiceAsync(
    std::string name,
    std::string service,
    std::function< void(std::vector< dns::SRVData >)> resultHandler
) override
```

lookup srv records async 

**Reimplements**: [llarp::EndpointBase::LookupServiceAsync](Classes/classllarp_1_1EndpointBase.md#function-lookupserviceasync)


### function SendToOrQueue

```cpp
inline virtual bool SendToOrQueue(
    service::ConvoTag tag,
    std::vector< byte_t > data,
    service::ProtocolType t
) override
```


**Reimplements**: [llarp::EndpointBase::SendToOrQueue](Classes/classllarp_1_1EndpointBase.md#function-sendtoorqueue)


### function EnsurePathTo

```cpp
inline virtual bool EnsurePathTo(
    AddressVariant_t addr,
    std::function< void(std::optional< service::ConvoTag >)> hook,
    llarp_time_t timeout
) override
```

MUST call MarkAddressOutbound first if we are initiating the flow to the remote. 

**Reimplements**: [llarp::EndpointBase::EnsurePathTo](Classes/classllarp_1_1EndpointBase.md#function-ensurepathto)


### function autovivify_session_to

```cpp
inline const std::shared_ptr< exit::SNodeSession > & autovivify_session_to(
    RouterID remote
)
```


-------------------------------

Updated on 2023-02-23 at 21:24:54 +0000