---
title: llarp::layers::platform::OSTraffic
summary: platfrom datum that is used to read and write to the os 

---

# llarp::layers::platform::OSTraffic



platfrom datum that is used to read and write to the os 


`#include <traffic.hpp>`

## Public Attributes

|                | Name           |
| -------------- | -------------- |
| EtherType_t | **[kind](Classes/structllarp_1_1layers_1_1platform_1_1OSTraffic.md#variable-kind)** <br>the kind of traffic it is  |
| [PlatformAddr](Classes/structllarp_1_1layers_1_1platform_1_1PlatformAddr.md) | **[src](Classes/structllarp_1_1layers_1_1platform_1_1OSTraffic.md#variable-src)** <br>platform level source and destination addresses of this traffic  |
| [PlatformAddr](Classes/structllarp_1_1layers_1_1platform_1_1PlatformAddr.md) | **[dst](Classes/structllarp_1_1layers_1_1platform_1_1OSTraffic.md#variable-dst)**  |
| std::vector< byte_t > | **[data](Classes/structllarp_1_1layers_1_1platform_1_1OSTraffic.md#variable-data)** <br>the datum itself  |

## Public Attributes Documentation

### variable kind

```cpp
EtherType_t kind;
```

the kind of traffic it is 

### variable src

```cpp
PlatformAddr src;
```

platform level source and destination addresses of this traffic 

### variable dst

```cpp
PlatformAddr dst;
```


### variable data

```cpp
std::vector< byte_t > data;
```

the datum itself 

-------------------------------

Updated on 2023-02-23 at 21:24:54 +0000