---
title: llarp/layers/flow/flow_auth.hpp

---

# llarp/layers/flow/flow_auth.hpp



## Namespaces

| Name           |
| -------------- |
| **[llarp](Namespaces/namespacellarp.md)** <br>[crypto.hpp] |
| **[llarp::layers](Namespaces/namespacellarp_1_1layers.md)**  |
| **[llarp::layers::flow](Namespaces/namespacellarp_1_1layers_1_1flow.md)**  |




## Source code

```cpp
#pragma once

#include <functional>
#include <string>
#include <optional>

#include <llarp/util/formattable.hpp>

namespace llarp::layers::flow
{

  enum class FlowAuthPhase
  {
    auth_req_not_sent,
    auth_req_sent,
    auth_req_nack,
    auth_req_more,
    auth_req_ok,
  };

  std::string
  ToString(FlowAuthPhase phase);
}  // namespace llarp::layers::flow
```


-------------------------------

Updated on 2023-02-23 at 21:24:54 +0000
