---
title: llarp/layers/platform/traffic.hpp

---

# llarp/layers/platform/traffic.hpp



## Namespaces

| Name           |
| -------------- |
| **[llarp](Namespaces/namespacellarp.md)** <br>[crypto.hpp] |
| **[llarp::layers](Namespaces/namespacellarp_1_1layers.md)**  |
| **[llarp::layers::platform](Namespaces/namespacellarp_1_1layers_1_1platform.md)**  |

## Classes

|                | Name           |
| -------------- | -------------- |
| struct | **[llarp::layers::platform::OSTraffic](Classes/structllarp_1_1layers_1_1platform_1_1OSTraffic.md)** <br>platfrom datum that is used to read and write to the os  |




## Source code

```cpp
#pragma once
#include "ethertype.hpp"
#include "platform_addr.hpp"
#include <cstdint>
#include <vector>

namespace llarp::layers::platform
{
  struct OSTraffic
  {
    EtherType_t kind;
    PlatformAddr src, dst;
    std::vector<byte_t> data;
  };

}  // namespace llarp::layers::platform
```


-------------------------------

Updated on 2023-02-23 at 21:24:54 +0000
