---
title: llarp::layers::platform::PlatformDriver_pimpl

---

# llarp::layers::platform::PlatformDriver_pimpl





## Public Functions

|                | Name           |
| -------------- | -------------- |
| bool | **[put_exit_up](Classes/classllarp_1_1layers_1_1platform_1_1PlatformDriver__pimpl.md#function-put-exit-up)**()<br>put up the exit fire wall rules.  |
| void | **[put_exit_down](Classes/classllarp_1_1layers_1_1platform_1_1PlatformDriver__pimpl.md#function-put-exit-down)**()<br>put exit firewall rules down.  |
| | **[PlatformDriver_pimpl](Classes/classllarp_1_1layers_1_1platform_1_1PlatformDriver__pimpl.md#function-platformdriver-pimpl)**([AbstractRouter](Classes/structllarp_1_1AbstractRouter.md) & router_) |
| template <typename args_t \> <br>constexpr auto | **[make_waker](Classes/classllarp_1_1layers_1_1platform_1_1PlatformDriver__pimpl.md#function-make-waker)**(args_t && args) |

## Public Attributes

|                | Name           |
| -------------- | -------------- |
| [AbstractRouter](Classes/structllarp_1_1AbstractRouter.md) & | **[router](Classes/classllarp_1_1layers_1_1platform_1_1PlatformDriver__pimpl.md#variable-router)**  |
| std::shared_ptr< [dns::Resolver_Base](Classes/classllarp_1_1dns_1_1Resolver__Base.md) > | **[dns_glue](Classes/classllarp_1_1layers_1_1platform_1_1PlatformDriver__pimpl.md#variable-dns-glue)**  |

## Public Functions Documentation

### function put_exit_up

```cpp
inline bool put_exit_up()
```

put up the exit fire wall rules. 

return true if we put them up successfully. 


### function put_exit_down

```cpp
inline void put_exit_down()
```

put exit firewall rules down. 

### function PlatformDriver_pimpl

```cpp
inline PlatformDriver_pimpl(
    AbstractRouter & router_
)
```


### function make_waker

```cpp
template <typename args_t >
inline constexpr auto make_waker(
    args_t && args
)
```


## Public Attributes Documentation

### variable router

```cpp
AbstractRouter & router;
```


### variable dns_glue

```cpp
std::shared_ptr< dns::Resolver_Base > dns_glue;
```


-------------------------------

Updated on 2023-02-23 at 21:24:54 +0000