---
title: llarp/layers/flow/flow_traffic.hpp

---

# llarp/layers/flow/flow_traffic.hpp



## Namespaces

| Name           |
| -------------- |
| **[llarp](Namespaces/namespacellarp.md)** <br>[crypto.hpp] |
| **[llarp::layers](Namespaces/namespacellarp_1_1layers.md)**  |
| **[llarp::layers::flow](Namespaces/namespacellarp_1_1layers_1_1flow.md)**  |

## Classes

|                | Name           |
| -------------- | -------------- |
| struct | **[llarp::layers::flow::FlowTraffic](Classes/structllarp_1_1layers_1_1flow_1_1FlowTraffic.md)**  |




## Source code

```cpp
#pragma once

#include "flow_data_kind.hpp"
#include "flow_info.hpp"

namespace llarp::layers::flow
{

  struct FlowTraffic
  {
    FlowInfo flow_info;
    std::vector<byte_t> datum;
    FlowDataKind kind;
  };

}  // namespace llarp::layers::flow
```


-------------------------------

Updated on 2023-02-23 at 21:24:54 +0000
